#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <math.h>
#include "timing.h"

int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;


double *a, *b, *c;
a = (double *) malloc(N * sizeof(double) );

int i;

for(i=0; i<N; i++) {
	a[i] = (double) i;
	//a[i] = (double) rand() / RAND_MAX;
}

get_ticks(ticksB4);

double norm = 0.;

#pragma omp parallel num_threads(nthreads)
{
#pragma omp for reduction(+:norm)
for(i=0; i<N; i++) {
	a[i] = a[i]*a[i];
	norm += a[i]*a[i];
}
#pragma omp single
{
norm = 1./sqrt(norm);
}

#pragma omp for
for(i=0; i<N; i++) {
	a[i] = a[i] * norm;
}
}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

/*
printf("\na:");
for(i=0; i<N; i++) {
	printf(" %.3g", a[i]);
}
printf("\n\n");
*/

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
