#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include "timing.h"


int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;


double *a, *b, *c;
a = (double *) malloc(N * sizeof(double) );
b = (double *) malloc(N * sizeof(double) );
c = (double *) malloc(N * sizeof(double) );

int i;

for(i=0; i<N; i++) {
	a[i] = (double) i;
	b[i] = (double) i;
	c[i] = (double) i;
}

get_ticks(ticksB4);

#pragma omp parallel num_threads(nthreads) private(i)
{
int id = omp_get_thread_num();
int chunk_size = (N-1) / nthreads;

int start = id * chunk_size;
int end = (id+1) * chunk_size;

if (id == nthreads-1)
	end = N-1;

double temp = a[end];

#pragma omp barrier

for(i=start; i<end-1; i++) {
	a[i] = a[i+1] + b[i]*c[i];
	//printf("thread %d updated %d, a[i+1] = %.3g b[i] = %.3g c[i] = %.3g\n", id, i, a[i+1], b[i], c[i]);
}
a[end-1] = temp + b[end-1]*c[end-1];

}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

printf("\na:");
for(i=0; i<N; i++) {
	printf(" %.3g", a[i]);
}
printf("\n\n");

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
