#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include "timing.h"


int main(int argc, char *argv[])
{
int N = atoi(argv[1]);
int nthreads = atoi(argv[2]);
unsigned long ticksB4, ticksAFT, ticks;
double freq = 2.5e9;


double *a, *b, *c, *d;
a = (double *) malloc(N * sizeof(double) );
b = (double *) malloc(N * sizeof(double) );
c = (double *) malloc(N * sizeof(double) );
d = (double *) malloc(N * sizeof(double) );

int i;

for(i=0; i<N; i++) {
	a[i] = (double) i;
	b[i] = (double) i;
	c[i] = (double) i;
}

get_ticks(ticksB4);

double t = 1.;

#pragma omp parallel num_threads(nthreads)
{
#pragma omp for
for(i=0; i<N; i++) {
	d[i] = a[i];
}

#pragma omp for reduction(*:t)
for(i=0; i<N-1; i++) {
	a[i] = d[i+1] + b[i]*c[i];
	t = t*a[i];
	//printf("thread %d updated %d, a[i+1] = %.3g b[i] = %.3g c[i] = %.3g\n", id, i, a[i+1], b[i], c[i]);
}
}

get_ticks(ticksAFT);
ticks = ticksAFT - ticksB4;

printf("\nt = %.3g\n", t);

printf("\na:");
for(i=0; i<N; i++) {
	printf(" %.3g", a[i]);
}
printf("\n\n");

printf("runtime (s): %g\n\n", ticks/freq);

return 0;
}
